#!/usr/bin/env python3
#usage:
# $ convert a.png a.rgb
# $ ./conv.py a.rgb
# $ ./bpppp 74 mode7.bin tiles.bin
import sys,array
rawbytes = open(sys.argv[1], "rb").read()

palarray = array.array("H")
tilearray = array.array("B", [0]*256*224)
palette = {}

for n in range(0, len(rawbytes)//3):
	pixel = rawbytes[n*3+0]*65536 + rawbytes[n*3+1]*256 + rawbytes[n*3+2]
	if pixel in palette:
		col = palette[pixel]
	else:
		col = len(palette)
		palette[pixel]=col
		b,g,r = pixel&0xFF, pixel>>8&0xFF, pixel>>16&0xFF
		#print(r,g,b)
		#print((b>>3<<10) + (g>>3<<5) + (r>>3))
		palarray.append((b>>3<<10) + (g>>3<<5) + (r>>3))
	x,y = n&255,n>>8
	tilenum = (y>>3)*32+(x>>3)
	tilearray[tilenum*64 + y%8*8 + x%8] = col

with open("palette.bin", "wb") as f: palarray.tofile(f)
with open("mode7.bin", "wb") as f: tilearray.tofile(f)
