#!/usr/bin/env python3
import array
import sys

lines = []
for line in sys.stdin: lines.append(line) # force wait until Asar is done


def adc(val):
	global a,c
	a = a+val+c
	c = (a > 65535)
	a = a & 65535

def sbc(val):
	global a,c
	a = a-val-(not c)
	c = (a >= 0)
	a = a&65535

def eor(val):
	global a,c
	a = a^val

def solve_adc(target):
	global a,c
	ret = (target-a-c)&65535
	adc(ret)
	return ret

def solve_sbc(target):
	global a,c
	ret = (a-(not c)-target)&65535
	sbc(ret)
	return ret

def solve_eor(target):
	global a,c
	ret = a^target
	eor(ret)
	return ret


f = open("Z3.sfc", "r+b")

a = 0
c = 0


for line in lines:
	if not line.startswith('CODE'): continue
	words = line.split()
	
	op = words[1]
	if op=='C': c = int(words[2]) # carry
	if op=='I': a = int(words[2]) # initial
	if op=='BW': # block, words
		start = int(words[3])
		len = int(words[4])
		
		if words[2]=='ADC':
			ex = adc
			solve = solve_adc
		if words[2]=='SBC':
			ex = sbc
			solve = solve_sbc
		if words[2]=='EOR':
			ex = eor
			solve = solve_eor
		
		data = array.array("H")
		f.seek(start)
		data.fromfile(f, len)
		for x in range(len):
			x = len-1-x
			data[x] = solve(data[x])
		f.seek(start)
		data.tofile(f)
